<h1 align="center">ComposeCookBook</h1>

<div align="center">
  <strong>Declarative UI</strong>
</div>
<div align="center">
  A Collection of all Jetpack compose UI elements, Layouts, Widgets and Demo screens to see it's potential.
</div>
<div align="center">
 <img src = "https://github.com/Gurupreet/ComposeCookBook/blob/master/screens/composelogo.png" width = "300px"/>
</div>

<br />

<div align="center">
    <a href = "https://developer.android.com/jetpack/androidx/versions/all-channel#december_16_2020">
      <img src = "https://img.shields.io/badge/Jetpack%20Compose-1.0.0%20beta05-brightgreen" />
    </a>
  <a href = "https://github.com/Gurupreet/ComposeCookBook/network/">
    <img src = "https://img.shields.io/github/forks/Gurupreet/ComposeCookBook" />
  </a>
  <a href = "https://github.com/Gurupreet/ComposeCookBook/stargazers">
     <img src = "https://img.shields.io/github/stars/Gurupreet/ComposeCookBook" />
  </a>
  <a href = "https://github.com/Gurupreet/ComposeCookBook/issues">
     <img src = "https://img.shields.io/github/issues/Gurupreet/ComposeCookBook" />
  </a>  
    <a href = "https://github.com/Gurupreet/ComposeCookBook/blob/master/LICENSE">
     <img src = "https://img.shields.io/github/license/Gurupreet/ComposeCookBook" />
  </a> 
  <a href = "https://twitter.com/_gurupreet">
     <img src = "https://img.shields.io/twitter/url?label=follow&style=social&url=https%3A%2F%2Ftwitter.com%2F_gurupreet" />
  </a>
</div>

# Jetpack Compose
Jetpack Compose is Android’s modern toolkit for building native UI. It simplifies and accelerates UI development on Android. Quickly bring your app to life with less code, powerful tools, and intuitive Kotlin APIs.

### Jetpack compose for Desktop:
[Compose Spotify Desktop](https://github.com/Gurupreet/ComposeSpotifyDesktop)
### FontAwesomeIcons in Compose:
[FontAwesome Icon Library ](https://github.com/Gurupreet/FontAwesomeCompose)

## Screens
List & Layouts             |  Widgets and building blocks| Animations | Theme
:-------------------------:|:-------------------------: | :-------------------------: | :-------------------------:
![](https://media.giphy.com/media/WOlo2cTDdjGkgdAJQK/giphy.gif)  |  ![](https://media.giphy.com/media/RkEyxCn43aX1MoIdcx/giphy.gif) | ![](https://media.giphy.com/media/pZfwwwOlKQtiyJFPr2/giphy.gif) | ![](https://media.giphy.com/media/kPt0nCCWAcahhJsJh6/giphy.gif)

### Demo UI
Spotify             |  Instagram Demo | Twitter, Gmail, Youtube                       | Profile
:-------------------------:|:-------------------------: | :-------------------------: | :-------------------------:
![](https://media.giphy.com/media/IddlpOpdboqJwdhxMS/giphy.gif)  |  ![](https://media.giphy.com/media/XSh4SKvAgr6Moj3SDH/giphy.gif) | ![](https://media.giphy.com/media/sEe1vREivaK7ieMPYj/giphy.gif) | ![](https://media.giphy.com/media/n3UTF9SzLpBGneFyj3/giphy.gif)

Gmail full             |  Tiktok                   
:-------------------------:|:-------------------------:
![](https://media.giphy.com/media/hrOVD7rbST5shclGkQ/giphy.gif)  |  ![](https://media.giphy.com/media/cimocpJnmSBeJIPxu2/giphy.gif)


### Apps with Api, Retrofit, Room, Flow, Livedata Integration
CryptoApp MVVM             |  MovieApp MVI              | Dating APP DEMO UI
:-------------------------:|:-------------------------: | :-------------------------:
![](https://media.giphy.com/media/OtJXUCh2ITINfKuTc0/giphy.gif)  |  ![](https://media.giphy.com/media/BfHMR2EMJkzB1agvpk/giphy.gif) | ![](https://media.giphy.com/media/tVXmwM2ryGlhCcf3Kl/giphy.gif)

### Advance lists and animations
Shimmer Lists             | List Scroll Animations       
:-------------------------:|:-------------------------: 
![](https://media.giphy.com/media/VQof1yEEbEgcqgY7WW/giphy.gif)  |  ![](https://media.giphy.com/media/hhpnI1beJr6gRi4btK/giphy.gif)

### Templates
Adding card details        | 
:-------------------------:|
![](https://user-images.githubusercontent.com/8813304/112016144-1e21ef00-8b35-11eb-8c33-362c8cbe6c0d.gif)  | 

## If this project helped you in any way feel free to show some love
<a href="https://www.buymeacoffee.com/gurupreet" target="_blank">
    <img src="https://cdn.buymeacoffee.com/buttons/v2/default-yellow.png" alt="Buy Me A Coffee" width="160">
</a>

## How to get started
Please get **Android Studio Arctic Fox 2020.3.1 Canary 4** or above to build this project [from here](https://developer.android.com/studio/preview/).

## Features & Where to start
- __Widgets:__ Widgets Screen show case all the available components to build UI.
- __Home Screen:__ Start with Layouts, Modifiers and Simple Listviews
- __Demo UI:__ Learn how demo UI have been made by using layouts, listviews and widgets.
- __Animations:__ Animations are very interesting in compose. Checkout single value animations to get started.
- __UI Tests:__ Checkout UI tests to understand how we can test compose UI.
- __Others:__ After the above steps feel free to deep dive into Tablayouts, carousel, Dialogs and BottomSheets 


## Coming Soon
- Some of the features that will be available in coming weeks
  - Advance lists: Pull Refresh, Swipe lsits etc
  - Clean Architecture Sample with coroutines.
  - Advance canvas drawing. 
  Much more in pipeline stay tuned!!

## Official Documentations
- Official Google Documentation
  - [Compose Pathway](https://developer.android.com/courses/pathways/compose)
  - [Jetpack compose](https://developer.android.com/jetpack/compose)
  - [Jetpack compose Samples](https://github.com/android/compose-samples)
  
- [Compose Academy ](https://compose.academy/)

## Contribution Info
- All the contributions are welcomed keeping following points in mind.
  - If it's a widget/tool/UI element newly added please add to Widget Screen
  - Any feature showcase like Collapsing AppBar, BottomSheets, Dialogs etc add in HomeScreen list
  - Any Demo UI please add to Demo UI section
  - Try not to add new Icons/Images unless must be needed.
  - Please make sure whatever you add also supports dark mode as well.
  Thanks happy coding 


## Please Share & Star the repository to keep me motivated.
  <a href = "https://github.com/Gurupreet/ComposeCookBook/stargazers">
     <img src = "https://img.shields.io/github/stars/Gurupreet/ComposeCookBook" />
  </a>
  <a href = "https://twitter.com/_gurupreet">
     <img src = "https://img.shields.io/twitter/url?label=follow&style=social&url=https%3A%2F%2Ftwitter.com%2F_gurupreet" />
  </a>

